%% ------  Lezione 2, 10 ottobre 2016 ------ 
% Seconda parte del tutorial introduttivo su matlab:
% Istruzioni condizionali
% Soluzione degli esercizi.
%
% Nota: questa vuole essere semplicemente una traccia
% di soluzione: tipicamente, ci sono diverse strade
% per raggiungere lo stesso risultato

clear all; % cancella il contenuto di memoria
close all; % chiude tutte le figure presenti nella sessione
clc; % pulisce lo schermo

%% Esercizio 1
% Generare un numero casuale con il comando randn (distribuzione normale
% standard). 
% Assegnare alla variabile y il valore 1 se tale numero e' compreso tra 
% -1 e 1 (media +- deviazione standard), 0 altrimenti.
x = randn;
if x < 1 && x > -1
    y = 1;
else
    y = 0;
end
fprintf('Numero generato: ')
x
fprintf('E'' compreso fra -1 e 1?')
y
 
% Se ripeto il procedimento 10000 volte, quante volte il numero casuale
% cade nell'intervallo [-1 1]?
% Risolvere l'esercizio senza usare cicli
% (suggerimento: consultate l'help della funzione randn)
x = randn([1 10000]); % Genero un vettore con 10000 numeri casuali
y = x < 1 & x > -1; % Fuori dall'if, uso un singolo &
totale = sum(y);
fprintf('Quante volte il numero è compreso fra -1 e 1?')
totale

% Trovare inoltre l'indice del primo elemento minore di -1.
indice = find(x < -1);
fprintf('Indice del primo elemento minore di -1:')
indice(1) % prendo il primo valore del vettore "indice"
% Stampo anche il valore per essere sicuro che,
% in posizione indice(1) ci sia effettivamente un numero minore
% di -1
valore = x(indice(1)) 

% Funzioni utili:
% - randn
% - sum
% - find


%% Esercizio 2
% Data l'immagine I (è una matrice) di cellule U2OS 
% (Human Bone Osteosarcoma), provare ad evidenziare i nuclei. 
% Idea: a partire da I, cercare solo i valori sopra una certa soglia.
% Provare prima con una soglia di 30, quindi con una soglia di 70.
%
% Costruire inoltre un subplot dove l'immagine originale viene affiancata
% all'immagine in cui sono evidenziati i nuclei.

clear I;
% La seguente istruzione funziona solo se questo script si trova
% nella stessa cartella dell'immagine.
% In alternativa, bisogna specificare il path dell'immagine "cells.png"
% rispetto alla cartella corrente in cui si trova Matlab.
I = imread('cells.png'); 

% Idea: Trasformo l'immagine in una matrice binaria - 1 se il pixel è 
% sopra la soglia (es. 30), 0 altrimenti
I_30 = I > 30; 
I_70 = I > 70;
subplot(1,2,1);
imagesc(I); title('Immagine originale')
subplot(1,2,2);
imagesc(I_30); title('Nuclei evidenziati');








