%% ------  Lezione 2, 10 ottobre 2016 ------ 
% Seconda parte del tutorial introduttivo su matlab:
% Istruzioni condizionali, cicli, strutture dati avanzate

clear all; % cancella il contenuto di memoria
close all; % chiude tutte le figure presenti nella sessione
clc; % pulisce lo schermo

%% Esercizio 1
% Sono date le matrici U e V. Ogni riga di U o di V
% corrisponde ad un punto nello spazio euclideo 2D. 
% Costruire una matrice di distanze D per cui un elemento D(i,j) 
% contenga la distanza euclidea fra U(i,:) e V(j,:)
U = [0 0; 0 1; 1 0]; % Il primo punto ha coordinate (0,0)
V = [-1 -1; 1 1; 4 4]; % Il primo punto ha coordinate (-1,-1)

for i = 1:size(U, 1) % un'iterazione per ogni riga di U
    for j = 1:size(V,1) % un'iterazione per ogni riga di V
        D(i,j) = sqrt(sum((U(i,:) - V(j,:)).^2));
    end
end
fprintf('Matrice di distanze: ')
D


%% Esercizio 2
% Caricare nel workspace l'immagine "seattle.png", assegnandola alla
% variabile I.
% Costruire una nuova matrice Ih in cui ad ogni elemento di I viene
% sottratto il suo precedente sulle colonne (in valore assoluto).
% In altre parole, l'elemento (i,j) della nuova matrice Ih deve essere
% uguale a   abs( I(i,j) - I(i-1,j) ).
% (attenzione agli indici di inizio e fine del for)
I = imread('seattle.png');
for i = 2:size(I,1)
    Ih(i,:) = abs(I(i,:) - I(i-1,:));
end
figure
subplot(1,2,1), imagesc(I), title('Immagine originale')
subplot(1,2,2), imagesc(Ih), title('Evidenziati i contorni orizzontali')

% Ripetere l'esercizio costruendo l'immagine Iv, ottenuta
% sottraendo ad ogni elemento quello adiacente sulle
% righe: Iv(i,j) = abs( I(i,j) - I(i,j-1) ).
for i = 2:size(I,2)
    Iv(:,i) = abs(I(:,i) - I(:,i-1));
end
figure
subplot(1,2,1), imagesc(I), title('Immagine originale')
subplot(1,2,2), imagesc(Iv), title('Evidenziati i contorni verticali')



